#version 120

#include "lib/defines.glsl"

uniform sampler2D texture;
uniform vec4 entityColor;

varying vec2 lmcoord;
varying vec2 texcoord;
varying vec4 tint;

void main() {
	vec4 color = texture2D(texture, texcoord) * tint;
	color.rgb = mix(color.rgb, entityColor.rgb, entityColor.a);

	if (color.a < 0.01) discard; //fix phantoms

/* DRAWBUFFERS:04 */
	gl_FragData[0] = color; //gcolor
	gl_FragData[1] = vec4(lmcoord, 1.0, step(0.75, color.a)); //gaux1
}